package be.iminds.ilabt.jfed.rspec.ext.jfedbonfire;


import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.NONE)
@XmlRootElement(namespace = "http://jfed.iminds.be/rspec/ext/jfed-bonfire/1", name = "bonfire_node_info")
public class BonfireNodeInfo {

    @XmlAccessorType(XmlAccessType.NONE)
    @XmlRootElement(namespace = "http://jfed.iminds.be/rspec/ext/jfed-bonfire/1", name = "storage")
    public static class StorageHref {
        @XmlAttribute(name = "href")
        private String href;

        public StorageHref() {
            this.href = null;
        }

        public StorageHref(String href) {
            this.href = href;
        }

        public String getHref() {
            return href;
        }

        public void setHref(String href) {
            this.href = href;
        }
    }

    @XmlAccessorType(XmlAccessType.NONE)
    @XmlRootElement(namespace = "http://jfed.iminds.be/rspec/ext/jfed-bonfire/1", name = "network")
    public static class NetworkHref {
        @XmlAttribute(name = "href")
        private String href;

        public NetworkHref() {
            this.href = null;
        }

        public NetworkHref(String href) {
            this.href = href;
        }

        public String getHref() {
            return href;
        }

        public void setHref(String href) {
            this.href = href;
        }
    }


    private StringProperty instanceType = new SimpleStringProperty();

    @XmlElement(name = "network")
    private ObservableList<NetworkHref> networkHrefs = FXCollections.observableArrayList();

    @XmlElement(name = "storage")
    private ObservableList<StorageHref> storageHrefs = FXCollections.observableArrayList();

    public BonfireNodeInfo() {
        this.instanceType.setValue("lite");
    }

    public BonfireNodeInfo(BonfireNodeInfo o) {
        set(o);
    }

    //set so it is the same as a given BonfireNodeInfo
    public void set(BonfireNodeInfo o) {
        this.instanceType.setValue(o.instanceType.getValue());
        this.networkHrefs.setAll(o.networkHrefs);
        this.storageHrefs.setAll(o.storageHrefs);
    }

    @XmlAttribute(name = "instance_type")
    public String getInstanceType() {
        return instanceType.get();
    }

    public void setInstanceType(String instanceType) {
        this.instanceType.set(instanceType);
    }

    public StringProperty instanceTypeProperty() {
        return instanceType;
    }

    public ObservableList<NetworkHref> getNetworkHrefs() {
        return networkHrefs;
    }

    public ObservableList<StorageHref> getStorageHrefs() {
        return storageHrefs;
    }
}
